package joanakey;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.function.BiConsumer;
import java.util.function.Supplier;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.stream.Collectors;

import org.json.JSONArray;
import org.json.JSONObject;

import com.ibm.wala.ipa.callgraph.pruned.ApplicationLoaderPolicy;
import com.ibm.wala.ipa.cha.ClassHierarchyException;
import com.ibm.wala.util.CancelException;
import com.ibm.wala.util.NullProgressMonitor;
import com.ibm.wala.util.graph.GraphIntegrity.UnsoundGraphException;

import edu.kit.joana.api.IFCAnalysis;
import edu.kit.joana.api.annotations.IFCAnnotation;
import edu.kit.joana.api.lattice.BuiltinLattices;
import edu.kit.joana.api.sdg.SDGCall;
import edu.kit.joana.api.sdg.SDGConfig;
import edu.kit.joana.api.sdg.SDGProgram;
import edu.kit.joana.api.sdg.SDGProgramPart;
import edu.kit.joana.ifc.sdg.core.SecurityNode;
import edu.kit.joana.ifc.sdg.core.violations.IViolation;
import edu.kit.joana.ifc.sdg.graph.SDG;
import edu.kit.joana.ifc.sdg.graph.SDGNode;
import edu.kit.joana.ifc.sdg.mhpoptimization.MHPType;
import edu.kit.joana.ifc.sdg.util.JavaMethodSignature;
import edu.kit.joana.util.Stubs;
import edu.kit.joana.wala.core.SDGBuilder.ExceptionAnalysis;
import edu.kit.joana.wala.core.SDGBuilder.FieldPropagation;
import edu.kit.joana.wala.core.SDGBuilder.PointsToPrecision;
import joanakey.annotations.ExtractAnnotations;
import joanakey.annotations.SDGAnnotationAdder;
import joanakey.annotations.SingleAnnotationAdder;
import joanakey.violations.ViolationsDisproverSemantic;

/**
 * Entry of the combined approach. 
 * This class can parse a given .joak file, which is generated by the spec gui and perform a {@link IFCAnalysis} with Joana.
 * The result of the {@link IFCAnalysis} and the information of the .joak file are used to generate a {@link JoanaAndKeYCheckData}.
 * @author joachim,..
 *
 */
public class CombinedApproach {
    public static final String PATH_KeY = "pathKeY";
    public static final String JAVA_CLASS = "javaClass";
    public static final String PATH_TO_JAR = "pathToJar";
    public static final String PATH_TO_JAVA = "pathToJavaFile";
    public static final String PATH_TO_SDG = "pathToSDG";
    public static final String ENTRY_METHOD = "entryMethod";
    public static final String ANNOTATION_PATH = "annotationPath";
    public static final String FULLY_AUTOMATIC = "fullyAutomatic";
    public static final String PATH_TO_STATE_SAVER = "pathToSaver";
    public static final String PATH_TO_DIRECTORY = "directoryPath";

    public static final String SRCS = "sources";
    public static final String SNKS = "sinks";

    public static final String HIGH_SECURITY = "high";
    public static final String LOW_SECURITY = "low";

    public static final String FROM = "from";
    public static final String CALLS_TO_METHOD = "callsToMethod";
    public static final String PROGRAM_PART = "programPart";
    public static final String SECURITY_LEVEL_CAT = "securityLevel";
    public static final String METHOD_CAT = "method";
    public static final String PARAM_POS_CAT = "paramPos";
    public static final String DESCR_CAT = "description";
    public static final String SDG_NODE = "sdgNode";
    public static final String SDG_NODE_ID = "sdgNodeId";

//    public static void main(String[] args) {
//        try {
//            JoanaAndKeyCheckData parsedCheckData =
//                      CombinedApproach.parseInputFile("testdata/jzip.joak");
//            CombinedApproach.runTestFromCheckData(parsedCheckData);
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }

    public static void runTestFromCheckData(JoanaAndKeYCheckData checkData)
            throws ClassHierarchyException, IOException,
                   UnsoundGraphException, CancelException,
                   CancelException {
        checkData.addAnnotations();
        AutomationHelper automationHelper =
                new AutomationHelper(checkData.getPathToJavaFile());
        ViolationsDisproverSemantic violationsViaKeyChecker
                = new ViolationsDisproverSemantic(automationHelper, checkData);
        checkAnnotatedPDGWithJoanaAndKeY(checkData.getAnalysis(),
                                         violationsViaKeyChecker);
    }

    public static void checkAnnotatedPDGWithJoanaAndKeY(
            IFCAnalysis annotatedAnalysis, ViolationsDisproverSemantic violationChecker)
                    throws FileNotFoundException {
        Collection<? extends IViolation<SecurityNode>> violations = annotatedAnalysis.doIFC();
        try {
            violationChecker.disproveViaKeY(annotatedAnalysis, violations,
                                            annotatedAnalysis.getProgram().getSDG());
        } catch (IOException ex) {
            Logger.getLogger(CombinedApproach.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void addAnnotationsFileBased(IFCAnalysis ana,
                                               List<String> annotationsSink,
                                               List<String> annotationsSource,
                                               String annotationPath)
                                           throws IOException {
        FileInputStream annotationSourceStream =
                new FileInputStream(annotationPath);
        Collection<IFCAnnotation> annotationCollection
                = ExtractAnnotations.loadAnnotations(annotationSourceStream,
                                                     ana.getProgram());
        annotationCollection.forEach((annotation) -> {
            ana.addAnnotation(annotation);
        });
    }
    
    private static String readJsonFile(File fileToLoad) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(fileToLoad));
        StringBuilder completeString = new StringBuilder();
//        completeString.append("{\n");
        for (String line = br.readLine(); line != null; line = br.readLine()) {
            if (line.trim().startsWith("//")) {
                continue;
            }
            completeString.append(line + '\n');
        }
        br.close();
//        completeString.append("}\n");
        return completeString.toString();
    }

    /**
     * parse a .joak file and generate {@link JoanaAndKeYCheckData}.
     * @param filetoload the .joak file you want to parse.
     * @return {@link JoanaAndKeYCheckData} 
     * @throws IOException
     * @throws ClassHierarchyException
     * @throws UnsoundGraphException
     * @throws CancelException
     */
    public static JoanaAndKeYCheckData parseInputFile(File filetoload)
            throws IOException, ClassHierarchyException,
                   UnsoundGraphException, CancelException {
        String joakFileString = "{\n"+readJsonFile(filetoload)+"}\n";
        JSONObject jsonObj = new JSONObject(joakFileString);
        String basePath = jsonObj.getString(PATH_TO_DIRECTORY);
        String pathKeY = jsonObj.getString(PATH_KeY);
        String pathToJar = jsonObj.getString(PATH_TO_JAR);
        String pathToJavaFile = jsonObj.getString(PATH_TO_JAVA);
        String pathToSDG = jsonObj.getString(PATH_TO_SDG);
        String pathToStateSaver = jsonObj.getString(PATH_TO_STATE_SAVER);
//        String pathToSDG = "";
        String entryMethodString = jsonObj.getString(ENTRY_METHOD);
        pathToJar = concatenatePaths(basePath, pathToJar);
        pathToJavaFile = concatenatePaths(basePath, pathToJavaFile);
        pathToSDG = concatenatePaths(basePath, pathToSDG);
        pathToStateSaver = concatenatePaths(basePath, pathToStateSaver);
        JavaMethodSignature entryMethod =
                JavaMethodSignature.mainMethodOfClass(entryMethodString);
        String annotationPath = jsonObj.getString(ANNOTATION_PATH);
        boolean fullyAutomatic = jsonObj.getBoolean(FULLY_AUTOMATIC);

        StateSaverCGConsumerBuilder stateSaverBuilder = new StateSaverCGConsumerBuilder();

        SDGAnalysis analysis = (SDGAnalysis) runJoanaCreateSDGAndIFCAnalyis(pathToJar, pathToSDG, entryMethod, stateSaverBuilder);
        StateSaver stateSaver;
        if (pathToSDG.isEmpty() && pathToStateSaver.isEmpty()) {
            stateSaver = stateSaverBuilder.buildStateSaver(analysis.getProgram().getSDG(), pathToJar, entryMethod.toString());
        } else {
            stateSaver = createStateSaverFromJSONFile(analysis.getProgram().getSDG(), pathToStateSaver,stateSaverBuilder, pathToJar, entryMethod.toString());
        }
        
        JSONArray sources = jsonObj.getJSONArray(SRCS);
        JSONArray sinks = jsonObj.getJSONArray(SNKS);

        ArrayList<SingleAnnotationAdder> singleAnnotationAdders = new ArrayList<>();
        
        sources.forEach((src) -> {
            JSONObject obj = (JSONObject) src;
            if (getJsonFrom(obj).equals(SDG_NODE)) {
                singleAnnotationAdders.add(
                        createSDGAnnotationAdder(obj, (node, sec) -> {
                            analysis.addSourceAnnotation(node, sec);
                        }, analysis)
                );
            } else {
                singleAnnotationAdders.add(
                        createAnnotationAdder(obj, (part, sec) -> {
                            analysis.addSourceAnnotation(part, sec);
                        }, analysis)
                );
            }
        });

        sinks.forEach((sink) -> {
            JSONObject obj = (JSONObject) sink;
            if (getJsonFrom(obj).equals(SDG_NODE)) {
                singleAnnotationAdders.add(
                        createSDGAnnotationAdder(obj, (node, sec) -> {
                            //FIXME  analysis.getProgram().findCoveringProgramPart(node) sometimes return null -> exception
                            analysis.addSinkAnnotation(node, sec);
                        }, analysis)
                );
            } else {
                
                singleAnnotationAdders.add(
                        createAnnotationAdder((JSONObject) sink, (part, sec) -> {
                            analysis.addSinkAnnotation(part, sec);
                        }, analysis)
                );
            }
        });
              
        return new JoanaAndKeYCheckData(
                pathKeY, pathToJar, pathToJavaFile, entryMethodString, annotationPath,
                entryMethod, fullyAutomatic, analysis, singleAnnotationAdders, stateSaver);
    }
    
    private static String getJsonFrom(JSONObject obj) {
        JSONObject description = obj.getJSONObject(DESCR_CAT);
        return description.getString(FROM);
    }

    private static SDGAnnotationAdder
            createSDGAnnotationAdder(JSONObject jsonObj,
                    BiConsumer<SDGNode,String> annoAddMethod,
                    SDGAnalysis analysis) {
        String securityLevelString = jsonObj.getString(SECURITY_LEVEL_CAT);
        String securityLevelLattice = "";
        if (securityLevelString.equals(HIGH_SECURITY)) {
            securityLevelLattice = BuiltinLattices.STD_SECLEVEL_HIGH;
        } else if (securityLevelString.equals(LOW_SECURITY)) {
            securityLevelLattice = BuiltinLattices.STD_SECLEVEL_LOW;
        }
        //Collection<SDGProgramPart> allProgramParts =
        //        analysis.getProgram().getAllProgramParts();
        JSONObject description = jsonObj.getJSONObject(DESCR_CAT);
        //String from = description.getString(FROM);
        Supplier<Collection<SDGNode>> nodeSupplier = null;
        //Supplier<Collection<SDGNode>> partSupplier = null;
        //String sdgNodeString = description.getString(SDG_NODE);
        int sdgNodeId = description.getInt(SDG_NODE_ID);
        nodeSupplier  = () -> {
                SDGNode node = analysis.getProgram().getSDG().getNode(sdgNodeId);
                //analysis.getProgram().findCoveringProgramPart(node);
                Collection<SDGNode> parts = new ArrayList<>();
                parts.add(node);
                return parts;
        };
        return new SDGAnnotationAdder(nodeSupplier, annoAddMethod, securityLevelLattice);
    }
    
    private static SingleAnnotationAdder
            createAnnotationAdder(JSONObject jsonObj,
                                  BiConsumer<SDGProgramPart, String> annoAddMethod,
                                  IFCAnalysis analysis) {
        String securityLevelString = jsonObj.getString(SECURITY_LEVEL_CAT);
        String securityLevelLattice = "";
        if (securityLevelString.equals(HIGH_SECURITY)) {
            securityLevelLattice = BuiltinLattices.STD_SECLEVEL_HIGH;
        } else if (securityLevelString.equals(LOW_SECURITY)) {
            securityLevelLattice = BuiltinLattices.STD_SECLEVEL_LOW;
        }

        Collection<SDGProgramPart> allProgramParts =
                analysis.getProgram().getAllProgramParts();

        JSONObject description = jsonObj.getJSONObject(DESCR_CAT);
        String from = description.getString(FROM);
        Supplier<Collection<SDGProgramPart>> partSupplier = null;
        if (from.equals(CALLS_TO_METHOD)) {
            int paramPos = description.getInt(PARAM_POS_CAT);
            String method = description.getString(METHOD_CAT);
            partSupplier
                    = () -> {
                        Collection<SDGCall> allCallsToMethod =
                                analysis.getProgram()
                                .getCallsToMethod(JavaMethodSignature.fromString(method));
                        List<SDGProgramPart> collectedParts =
                                allCallsToMethod.stream().map((SDGCall call) -> {
                            return (SDGProgramPart) call.getActualParameter(paramPos);
                        }).collect(Collectors.toList());

                        return collectedParts;
                    };
        } else if (from.equals(PROGRAM_PART)) {
            String programPartString = description.getString(PROGRAM_PART);
            partSupplier
                    = () -> {
                        Collection<SDGProgramPart> created = new ArrayList<>();
                        for (SDGProgramPart p : allProgramParts) {
                            if (p.toString().equals(programPartString)) {
                                created.add(p);
                            }
                        }
                        return created;
                    };
        }
//        } else if (from.equals(SDG_NODE)) {
//            String sdgNodeString = description.getString(SDG_NODE);
//            int sdgNodeId = description.getInt(SDG_NODE_ID);
//            
//            partSupplier 
//                = () -> {
//                    
//                    Collection<SDGProgramPart> parts = new ArrayList<>();
//                    //TODO: annotate the corresponding sdgNode
//                    //return new SingleSDGNodeAnnotationAdder(sdgNodeSupplier,...)
//                    return parts;
//                };
//                //return new SDGAnnotationAdder(partSupplier, annoAddMethod, securityLevelLattice)
//            
//        }
        return new SingleAnnotationAdder(partSupplier, annoAddMethod,
                                         securityLevelLattice);
    }
    
    /**
     * perform an IFCAnalysis with the sdg graph given in pathToSDG. 
     * If this sdg file does not exists, a new {@link SDGProgram}, with a new {@link SDG} is generated. 
     * If a new {@link SDGProgram} is generated, because of the missing file, the node id's of the new graph can be different from 
     * the node id's of the sdg graph generated in the spec gui ! 
     * This can be a problem if you have used the annotation with sdg nodes, in the spec gui.
     * @param pathToJar String path to the jar file, created by the spec gui.
     * @param pathToSDG String path to the SDG file, created by the spec gui.
     * @param entryMethod 
     * @param stateSaverBuilder
     * @return
     * @throws ClassHierarchyException
     * @throws IOException
     * @throws UnsoundGraphException
     * @throws CancelException
     */
    public static IFCAnalysis
                runJoanaCreateSDGAndIFCAnalyis(String pathToJar, String pathToSDG,
                                               JavaMethodSignature entryMethod,
                                               StateSaverCGConsumerBuilder stateSaverBuilder)
                               throws ClassHierarchyException, IOException,
                                      UnsoundGraphException, CancelException {
        
        File sdg = new File(pathToSDG);
        SDGProgram program;
        
        
        //TODO: write new methods for the two branches and catch empty sdg/saver files
        if (sdg == null || !sdg.exists() || pathToSDG.isEmpty()) { 
            SDGConfig config =
                    new SDGConfig(pathToJar, entryMethod.toBCString(), Stubs.JRE_15);
            config.setComputeInterferences(true);
            config.setMhpType(MHPType.PRECISE);
            config.setPointsToPrecision(PointsToPrecision.INSTANCE_BASED);
            config.setExceptionAnalysis(ExceptionAnalysis.INTERPROC);
            config.setFieldPropagation(FieldPropagation.OBJ_GRAPH_NO_MERGE_AT_ALL);
            // save intermediate results of SDG generation points to call graph
            config.setCGConsumer(stateSaverBuilder);
            // Schneidet beim SDG application edges raus, so besser sichtbar mit dem graphviewer
            config.setPruningPolicy(ApplicationLoaderPolicy.INSTANCE);
            //System.out.println("File not found: "+ pathToSDG);
            program = SDGProgram.createSDGProgram(config, System.out,
                    new NullProgressMonitor());
        } else {
            program = SDGProgram.loadSDG(pathToSDG, MHPType.PRECISE);
            //System.out.println("SDG loaded from file "+ pathToSDG);
        }
        //TODO check if some methods should be overwritten ?!
        SDGAnalysis ana = new SDGAnalysis(program);
        return ana;
    }
    
    private static String concatenatePaths(String firstPart, String secondPart) {
    	if (secondPart.contains(firstPart)) {
    		return secondPart;
    	}
    	if (firstPart.endsWith("/")) {
    		return firstPart+secondPart;
    	} else {
    		return firstPart+"/"+secondPart;
    	}
    }
    
    private static StateSaver createStateSaverFromJSONFile(SDG sdg , String pathToStateSaver, 
    			StateSaverCGConsumerBuilder stateSaverBuilder, String pathToJar, String entryMethod) throws IOException {
        File stateSaverFile = new File(pathToStateSaver);
        
        String jsonObjString = readJsonFile(stateSaverFile);
        return stateSaverBuilder.buildSateSaverFromJson(new JSONObject(jsonObjString), sdg, pathToJar, entryMethod);
    }
}
